// Version KEAterm 3.10 $RCSfile: apximage.ktm,v $ $Revision: 1.1 $
// ============================================================================
// ApxImage:    This Macro is conditionally executed before Pre-Display on all
//              Interactive Images.  To execute, the APPX_KEATERM environment
//              variable must be set to "buttons" and the KEATERM ACTIVE
//              Pre-Defined logic field must be "Y" which is the default value.
//
// [Passed Information]
//  
// PROCESS[]    Information about the current APPX process.  Elements include:
//      APID    Application ID
//      APDS    Application Descriptive Name
//      TYPE    Process Type
//      NAME    Process Name
//      DESC    Process Descriptive Name
//
// CHILD[][#]   Information about Child processes of the above defined process.
//              This is a two dimensional array.  The first element is one of
//              the following Index words & the second element is the Optional
//              Child number.  This array only contains Optional Children for
//              the current interactive image.
//      APID    Child Process Application ID
//      TYPE    Child Process Type
//      NAME    Child Process Name
//      DESC    Child Process Descriptive Name
//      CHID    Child ID
//      HIDE    Hidden Child Flag
//  
// ============================================================================

    Global ButtonState
    Global LastProc

    Process = Arg[1]
    Child   = Arg[2]

//
// Prevent Button flicker by stopping execution if the same buttonpad is being
// redisplayed.
//

    If  Process.APID = LastProc.APID
    and Process.NAME = LastProc.NAME
    and Process.TYPE = LastProc.TYPE
        Return
    Else
        LastProc.APID = Process.APID
        LastProc.NAME = Process.NAME
        LastProc.TYPE = Process.TYPE
    End

//
// For some reason, this function is still being called by 0LA-SCAN even
// with the KEATERM ACTIVE Pre-Defined Field set to "N".  If this is the case,
// exit without processing this call.
//

    If  Process.APID="0LA"
    And Process.NAME="SCAN"
        Return
    End

//
// Function definition of the ButtonPad Processor.  This will read the array
// of Child elements and produce a corresponding ButtonPad.  This function is
// Called from the following module.
//

Function InputProc()

    ButtonState = false
    Buttons     = false

    Var Count   = 0
    Var Width   = 30
    Var Xtra    = ""
    Var Option  = 0

    ButtonPad( Reset=true, ViewButtons=false )

    For Option In Child["DESC"]
        If Child["HIDE"][Option] <> "1"
            If Child["TYPE"][Option] = "MENU"
                Xtra = ".."
            Else
                Xtra = ""
            End
            Count = Count + 1
            ButtonPad( Caption=Child["DESC"][Option]+Xtra, MapTo="Macro",
             Value="ApxOpt(\""+Str(Option)+")\");LastProc=0",
             ViewButtons=false )
        End
    End
    ButtonPad( Caption="{ END }",MapTo="Macro",
     Value="SendKey(AppxKey[\"End\"])",
     ViewButtons=false, ButtonsOnStatusBar=false,
     Rows=Count+1, Columns=1, ButtonWidth=width )
    Buttons=true
End

//
// Select which function to execute based on Process.TYPE.  Currently,
// the same function is being executed for both MENU and INPUT
// interactive images.
//

    If Process.TYPE = "MENU"
        InputProc()
    Else
        InputProc()
    End

// [End of Macro]
