// Version KEAterm 3.10 $RCSfile: apxopt.ktm,v $   $Revision: 1.1 $
// ============================================================================
// ApxOpt:      This Macro examines a text string looking for trigger patterns
//              and sends the approriate key sequences  Valid patterns include:
//
//  [Mode:]
//              This string will result in a MODE dialog box being presented
//              to the user.  Clicking on a mode button sends the proper MODE
//              key sequence to the host.
//  [#)][##)]
//              One or two numeric digits followed by a ")" will transalate to
//              the correct option key sequence.
//  [RETURN]
//              This is any case will result in a "Return" key being sent.
//  [END]       
//              This text in any case will send the "End" key sequence.
//  [ACKNOWLEDGE]
//              This text in all Upper Case will send a "Go" + "DeleteMode"
//              sequence.
//
//  [PanRightMargin]    "PAN/PAN/PAN/CursorRight"
//  [PanScreenRight]    "PAN/PAN/CursorRight"
//  [PanRight]          "PAN/CursorRight"
//  [PanLeftMargin]     "PAN/PAN/PAN/CursorLeft" 
//  [PanScreenLeft]     "PAN/PAN/CursorLeft"
//  [PanLeft]           "PAN/CursorLeft"
//  [ScrollFirst]       "SCROLL/SCROLL/SCROLL/CursorUp"
//  [ScrollScreenUp]    "SCROLL/SCROLL/CursorUp"
//  [ScrollUp]          "SCROLL/CursorUp"
//  [ScrollLast]        "SCROLL/SCROLL/SCROLL/CursorDown"
//  [ScrollScreenDown]  "SCROLL/SCROLL/CursorDown"
//  [ScrollDown]        "SCROLL/CursorDown"
// ============================================================================

//
//  ModeDialog: This function will present a MODE Dialog box
//

Function ModeDialog( )
    Begin Dialog( "Mode" )
        Button( Text="Add"    ,Width=10 )
        Button( Text="Delete" ,Width=10 )
        Button( Text="Inquiry",Width=10 )
        Button( Text="Change" ,Width=10 )
    When Control( "Add"                 )
        SendKey( AppxKey["AddMode"    ] )
    When Control( "Delete"              )
        SendKey( AppxKey["DeleteMode" ] )
    When Control( "Inquiry"             )
        SendKey( AppxKey["InquiryMode"] )
    When Control( "Change"              )
        SendKey( AppxKey["ChangeMode" ] )
    End
End

//
//  Main Logic Section:
//  RawText: A text string that may contain a reference to an Appx key
//

    ReturnCode = 1
    RawText    = Arg[1]
        
    If RawText = " "                // Return if no text in input string
        Return 0
    End

    If  (InStr(RawText,"[1-9][0-9])*",Pat_RegExp) = 1)
 //   and (Len(RawText) = 3)
        SendKey(AppxKey["Option"])
        SendKey(AppxKey["Option"])
        SendKey(AppxKey[SubStr(RawText,1,1)])
        SendKey(AppxKey[SubStr(RawText,2,1)])
    ElseIf (InStr(RawText,"[1-9])*",Pat_RegExp) = 1)
 //   and    (Len(RawText) = 2)
        SendKey(AppxKey["Option"])
        SendKey(AppxKey[SubStr(RawText,1,1)])
    ElseIf (InStr(RawText,"R[Ee][Tt][Uu][Rr][Nn][)]-*",Pat_RegExp) = 1)
    and    (Len(RawText) < 8)
        SendKey(AppxKey["Return"])
    ElseIf (InStr(RawText,"E[Nn][Dd][)]-*",Pat_RegExp) = 1)
    and    (Len(RawText) < 5)
        SendKey(AppxKey["End"])
    ElseIf RawText = "PanRightMargin"
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["CursorRight"])
    ElseIf RawText = "PanScreenRight"
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["CursorRight"])
    ElseIf RawText = "PanRight"
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["CursorRight"])
    ElseIf RawText = "PanLeftMargin"
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["CursorLeft"])
    ElseIf RawText = "PanScreenLeft"
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["CursorLeft"])
    ElseIf RawText = "PanLeft"
        SendKey(Appxkey["Pan"])
        SendKey(Appxkey["CursorLeft"])
    ElseIf RawText = "ScrollFirst"
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["CursorUp"])
    ElseIf RawText = "ScrollScreenUp"
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["CursorUp"])
    ElseIf RawText = "ScrollUp"
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["CursorUp"])
    ElseIf RawText = "ScrollLast"
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["CursorDown"])
    ElseIf RawText = "ScrollScreenDown"
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["CursorDown"])
    ElseIf RawText = "ScrollDown"
        SendKey(Appxkey["Scroll"])
        SendKey(Appxkey["CursorDown"])
    ElseIf InStr(RawText, "ACKNOWLEDGE") > 0
        SendKey(Appxkey["Go"])
        SendKey(AppxKey["DeleteMode"])
    ElseIf RawText = "Mode:"
        ModeDialog()
    Else
        ReturnCode = 0
    End

    Return ReturnCode

//
//  [End of Macro]

